(require 'lock-window)
(require 'ignore-window)

(defvar compile-window nil)

(defun toggle-compile-window (&optional arg)
  "Maximize or minimize the compile window.
It is maximized if ARG is 0 and minimized if ARG is 1.  If ARG is nil, it is guessed."
  (interactive)
  (unless (window-live-p compile-window)
    (setq compile-window nil))
  (unless compile-window
    (error "No compile window"))
  (unless arg
    (if (= (window-height compile-window) 5)
        (setq arg 1)
      (setq arg 0)))
  (save-selected-window
    (select-window compile-window)
    (if (= arg 1)
        (enlarge-window (- (/ (frame-height (window-frame compile-window)) 2)
                           (window-height compile-window)))
      (shrink-window (- (window-height compile-window) 5)))))

(defun switch-to-compile-window ()
  (interactive)
  (select-window compile-window))


(defadvice compile (after compile-window activate)
  (unless compile-window
    (setq compile-window (get-buffer-window (get-buffer "*compilation*")))
    (lock-window compile-window)
    (ignore-window compile-window))
  (toggle-compile-window 1))

(global-set-key "\C-c." 'toggle-compile-window)
;; (global-set-key "\C-c," 'switch-to-compile-window)
